'''
# This is a ExcelToJson conversion tool for SnowGrains client application media handling.
# Usage:    go to <game root dir>/qml/game_config/
# python ../../SGEngine/tools/snowgrains_utils_excelToJson_converter.py snowgrains_game_config.xlsx SGMedia.js SGTuneItems.js SGSceneItems.js SGSceneRules.js SGTreasureItems.js SGInAppItems.js GameName

'''
import csv
import json
from pandas import *
import pandas as pd
import re

outFile1 = 'SGMedia.json'
outFile2 = 'SGTuneItems.json'
outFile3 = 'SGSceneItems.json'
outFile4 = 'SGSceneRules.json'
outFile5 = 'SGTreasureItems.json'
outFile6 = 'SGInAppItems.json'
# TODO: Take game name as an input parameter
game_name = 'SGTemplateApp'
#game_name = ''
copyright = '''
/************************************************************************************************
Copyrights SnowGrains 2014, all rights reserved.
www.snowgrains.com

Disclaimer:
SnowGrains ''' + game_name + ''' provided by SnowGrains is for fun and playing purposes only.
This does not guarantee that consumer learns math with the software.
This software is supplied "AS IS" without any warranties and support.

SnowGrains, its employees and software reseller assumes no responsibility or liability
for the use of the software, conveys no license or title under any patent, copyright,
or mask work right to the product.

SnowGrains reserves the right to make changes in the software without notification.

*************************************************************************************************/'''
#****************************************
# Set game_name given as an argument
#****************************************
def setGameName(arg_game_name):
    game_name = arg_game_name

#****************************************
# Functions for converting Excel to JSON
#****************************************
def excelToJson_media(inFile, outFile1):
    with open( inFile, 'r') as excelFile:
        #df = pd.ExcelFile(excelFile)
        #df.parse('Sheet1', index_col=None, na_values=['NA'])
        #outFile = 'SGMedia.json'
        sheet = 'Media'
        
        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )
        
        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile1, orient="records" )
        print "Done converting Excel to JSON."

def excelToJson_tuneItems(inFile, outFile2):
    with open( inFile, 'r') as excelFile:
        #outFile = 'SGTuneItems.json'
        sheet = 'Tune_Items'
        
        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )
        
        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile2, orient="records" )
        print "Done converting Excel to JSON."

def excelToJson_sceneItems(inFile, outFile3):
    with open( inFile, 'r') as excelFile:
        #outFile = 'SGTuneItems.json'
        sheet = 'Scene_Items'

        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )

        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile3, orient="records" )
        print "Done converting Excel to JSON."

def excelToJson_sceneRules(inFile, outFile4):
    with open( inFile, 'r') as excelFile:
        #outFile = 'SGTuneItems.json'
        sheet = 'Scene_Rules'

        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )

        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile4, orient="records" )
        print "Done converting Excel to JSON."
def excelToJson_treasureItems(inFile, outFile5):
    with open( inFile, 'r') as excelFile:
        #outFile = 'SGTuneItems.json'
        sheet = 'Treasure_Items'

        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )

        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile5, orient="records" )
        print "Done converting Excel to JSON."
def excelToJson_inappItems(inFile, outFile6):
    with open( inFile, 'r') as excelFile:
        #outFile = 'SGTuneItems.json'
        sheet = 'INAPP_Items'

        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, sheet, index_col=None, na_values=['NA'] )

        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile6, orient="records" )
        print "Done converting Excel to JSON."
'''
def excelToJson(inFile, outFile):
    with open( inFile, 'r') as excelFile:
        #df = pd.ExcelFile(excelFile)
        #df.parse('Sheet1', index_col=None, na_values=['NA'])

        # Parse Excel lines to DataFrame.
        data_frame = pd.read_excel( excelFile, 0 )
        # Push each Excel line as {} into a [] and write to outFile.  
        jsonFile = data_frame.to_json( outFile, orient="records" )
        print "Done converting Excel to JSON."
'''
#**************************************
# Functions for cleaning JSON to JS
#**************************************
def cleanJson_media(outFile1, cleanFile1):
    with open( outFile1, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        print "CLEAN_str: ", clean
        dirty_obj = json.loads( dirty )
        print "DIRTY_obj: ", dirty_obj, "\n"

        clean_obj = json.loads( clean )
        print "CLEAN_obj", clean_obj
        
    #if clean_obj:
        with open( cleanFile1, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var media = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean ) 
            #clean_obj = json.loads( clean )
            #for obj in clean_obj:
            #    cleanFile.write( json.dumps( clean_obj, indent=4 ))
            cleanFile.write( ";\n" )
            cleanFile.write( "function importMedia() { return media; };" )
            print "Clean Media written OK."
    #else:
     #   print "Error writing clean JSON!"

def cleanJson_tuneItems(outFile2, cleanFile2):
    with open( outFile2, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        clean2 = re.sub( r'\"\[', r'[', clean)
        clean3 = re.sub( r'\]"', r']', clean2)
        clean4 = re.sub( r'\'', r'"', clean3)
        print "CLEAN_str(3): ", clean4
        dirty_obj = json.loads( dirty )
        print "DIRTY_obj: ", dirty_obj, "\n"

        clean_obj = json.loads( clean4 )
        #clean_obj = clean3
        print "CLEAN_obj(3)", clean_obj
        
  #  if clean_obj:
        with open( cleanFile2, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var store_items = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean4 ) 
            cleanFile.write( ";\n" )
            cleanFile.write( "function importTuneItems() { return store_items; };" )
            print "Clean TuneItems written OK."
    #else:
    #    print "Error writing clean JSON!"

def cleanJson_sceneItems(outFile3, cleanFile3):
    with open( outFile3, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        clean2 = re.sub( r'\"\[', r'[', clean)
        clean3 = re.sub( r'\]"', r']', clean2)
        clean4 = re.sub( r'\'', r'"', clean3)
        print "CLEAN_str(3): ", clean4
        #dirty_obj = json.loads( dirty )
        #print "DIRTY_obj_scenes: ", dirty_obj, "\n"

        clean_obj = json.loads( clean4 )
        #clean_obj = clean3
        print "CLEAN_obj(3)_scenes", clean_obj
        
   # if clean_obj:
        with open( cleanFile3, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var scene_items = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean4 ) 
            cleanFile.write( ";\n" )
            cleanFile.write( "function importSceneItems() { return scene_items; };" )
            print "Clean SceneItems written OK."
    #else:
    #    print "Error writing clean JSON!"

def cleanJson_sceneRules(outFile4, cleanFile4):
    with open( outFile4, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        clean2 = re.sub( r'\"\[', r'[', clean)
        clean3 = re.sub( r'\]"', r']', clean2)
        clean4 = re.sub( r'\'', r'"', clean3)
        print "CLEAN_str(4): ", clean4
        #dirty_obj = json.loads( dirty )
        #print "DIRTY_obj_scenes: ", dirty_obj, "\n"

        clean_obj = json.loads( clean4 )
        #clean_obj = clean3
        print "CLEAN_obj(4)_scenes", clean_obj
        
   # if clean_obj:
        with open( cleanFile4, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var scene_rules = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean4 ) 
            cleanFile.write( ";\n" )
            cleanFile.write( "function importSceneRules() { return scene_rules; };" )
            print "Clean SceneRules written OK."
   # else:
   #     print "Error writing clean JSON!"

def cleanJson_treasureItems(outFile5, cleanFile5):
    with open( outFile5, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        clean2 = re.sub( r'\"\[', r'[', clean)
        clean3 = re.sub( r'\]"', r']', clean2)
        clean4 = re.sub( r'\'', r'"', clean3)
        print "CLEAN_str(4): ", clean4
        #dirty_obj = json.loads( dirty )
        #print "DIRTY_obj_scenes: ", dirty_obj, "\n"

        clean_obj = json.loads( clean4 )
        #clean_obj = clean3
        print "CLEAN_obj(5)_scenes", clean_obj
        
   # if clean_obj:
        with open( cleanFile5, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var treasure_items = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean4 ) 
            cleanFile.write( ";\n" )
            cleanFile.write( "function importTreasureItems() { return treasure_items; };" )
   #         print "Clean TreasureItems written OK."
   # else:
   #     print "Error writing clean JSON!"
def cleanJson_inappItems(outFile6, cleanFile6):
    with open( outFile6, 'r') as dirtyFile:
        dirty = dirtyFile.read()
        print "DIRTY_str: ", dirty
        clean = re.sub( r'\\/', r'/', dirty )
        clean2 = re.sub( r'\"\[', r'[', clean)
        clean3 = re.sub( r'\]"', r']', clean2)
        clean4 = re.sub( r'\'', r'"', clean3)
        print "CLEAN_str(4): ", clean4
        #dirty_obj = json.loads( dirty )
        #print "DIRTY_obj_scenes: ", dirty_obj, "\n"

        clean_obj = json.loads( clean4 )
        #clean_obj = clean3
        print "CLEAN_obj(6)_scenes", clean_obj
        
   # if clean_obj:
        with open( cleanFile6, 'w' ) as cleanFile:
            cleanFile.write( (copyright + "\n\n") )
            cleanFile.write( ".pragma library\n\n" )
            cleanFile.write( "var inapp_items = " )
            
            # This works == clean one_line_json  
            cleanFile.write( clean4 ) 
            cleanFile.write( ";\n" )
            cleanFile.write( "function importInAppItems() { return inapp_items; };" )
   #         print "Clean TreasureItems written OK."
   # else:
   #     print "Error writing clean JSON!"

#*********************************************
# Functions for pretty printing cleaned files
#*********************************************
'''
def prettyJson(cleanFile1):
    prettyFile = cleanFile + '_pretty'

    with open( cleanFile, 'r') as oneLineJson:
        json_obj = json.loads(oneLineJson)
        json_pretty = json.dumps( json_obj, indent=4)
    
    if json_pretty:
        with open( prettyFile, 'w' ) as prettyFile:
            prettyFile.write( json_pretty )
'''
#**************************************
# MAIN
#**************************************
if __name__ == "__main__":
    import argparse

    parser = argparse.ArgumentParser()
    parser.add_argument('inFile', nargs=1, help="Choose the in file to use")
    #parser.add_argument('outFile1', nargs=1, help="Choose the out file to use")
    parser.add_argument('cleanFile1', nargs=1, help="Choose the Media file to use")
    parser.add_argument('cleanFile2', nargs=1, help="Choose the TuneItems file to use")
    parser.add_argument('cleanFile3', nargs=1, help="Choose the SceneItems file to use")
    parser.add_argument('cleanFile4', nargs=1, help="Choose the SceneRules file to use")
    parser.add_argument('cleanFile5', nargs=1, help="Choose the TreasureItems file to use")
    parser.add_argument('cleanFile6', nargs=1, help="Choose the INAPP Items file to use")
    parser.add_argument('game_name', nargs=1, help="Choose the Game Name to be used")
    args = parser.parse_args()

    setGameName(args.game_name[0]);

    excelToJson_media( args.inFile[0]  , outFile1);
    cleanJson_media( outFile1 , args.cleanFile1[0] );
    #prettyJson( args.outFile[0] );

    excelToJson_tuneItems( args.inFile[0] , outFile2)
    cleanJson_tuneItems( outFile2 , args.cleanFile2[0] );

    excelToJson_sceneItems( args.inFile[0] , outFile3)
    cleanJson_sceneItems( outFile3 , args.cleanFile3[0] );

    excelToJson_sceneRules( args.inFile[0] , outFile4)
    cleanJson_sceneRules( outFile4 , args.cleanFile4[0] );

    excelToJson_treasureItems( args.inFile[0] , outFile5)
    cleanJson_treasureItems( outFile5 , args.cleanFile5[0] );

    excelToJson_inappItems( args.inFile[0] , outFile6)
    cleanJson_inappItems( outFile6 , args.cleanFile6[0] );
